/*
 * File: fxtra.c
 *  Contents: additional functions to extend the standard Icon repertoire.
 *  This file includes collections of functions, such as functions specific to
 *  MS-DOS (DosFncs).
 *
 *  These collections are under the control of conditional compilation
 *  as indicated by the symbols in parentheses. To enable a set of functions,
 *  define the corresponding symbol in ../h/define.h.  The functions themselves
 *  are in separate files, included according to the defined symbols.
 *
 *  CAVEAT:  Most of these functions have not yet been tested.  In
 *           addition, there are operating-system dependencies that
 *           are not noted.
 *
 *  The following persons contributed functions: Ralph Griswold,
 *  Gregg Townsend, Steve Wampler, and Cheyenne Wills.
 */

#include "../h/config.h"
#include "../h/rt.h"
#include "rproto.h"


#if VM
#include "fxvm.c"
#endif					/* VM */

#ifdef DosFncs
#include "fxmsdos.c"
#endif					/* DosFncs */


char fx_junk;				/* prevent empty module */
