/*
 *  Main program if Icon is called as a subprogram.
 */

#include "../h/config.h"
#include "../h/rt.h"
#include "rproto.h"

#ifdef CallIn

extern int call_failed;


novalue main(argc,argv)

int argc;
char *argv[];
{
   int myargc;
   char **myargv;
   int i;
   dptr retval;
   struct descrip darg;

#ifdef TallyOpt
   extern int tallyopt;
#endif					/* TallyOpt */

#ifdef ExecImages
  if (dumped) {
     /*
      * This is a restart of a dumped interpreter.  Normally, argv[0] is
      *  iconx, argv[1] is the icode file, and argv[2:(argc-1)] are the
      *  arguments to pass as a list to main().  For a dumped interpreter
      *  however, argv[0] is the executable binary, and the first argument
      *  for main() is argv[1].  The simplest way to handle this is to
      *  back up argv to point at argv[-1] and increment argc, giving the
      *  illusion of an additional argument at the head of the list.  Note
      *  that this argument is never referenced.
      */
     argv--; argc++;
     }
#endif					/* ExecImages */

#ifdef MaxLevel
   maxilevel = 0;
   maxplevel = 0;
   maxsp = 0;
#endif					/* MaxLevel */

#ifdef DumpIstream
   imons = fopen("icodes.mon",WriteText);
   if (imons == NULL) {
      fprintf(stderr,"cannot open icodes.mon\n");
      fflush(stderr);
      abort();
      }
#endif					/* DumpIstream */

#ifdef DumpIcount
   imonc = fopen("icodec.mon",WriteText);
   if (imonc == NULL) {
      fprintf(stderr,"cannot open icodec.mon\n");
      fflush(stderr);
      abort();
      }
#endif					/* DumpIcount */

/*
 * The following code is operating-system dependent [@istart.01].  Take special
 *  action if necessary to redirect output.
 */

#if PORT
   /* nothing to do */
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || HIGHC_386 || MACINTOSH || MSDOS || MVS || OS2 || UNIX || VM
   /* nothing to do */
#endif					/* AMIGA || ATARI_ST || HIGHC_386 ... */

#if VMS
   redirect(&argc, argv, 0);
#endif					/* VMS */

/*
 * End of operating-system specific code.
 */


/*
 * Handle command line options.
*/

   while ( argv[1] != 0 && *argv[1] == '-' ) {
      switch ( *(argv[1]+1) ) {

#ifdef TallyOpt
	/*
	 * Set tallying flag if -T option given
	 */
	case 'T':
	    tallyopt = 1;
	    break;
#endif					/* TallyOpt */

      /*
       * Set stderr to new file if -e option is given.
       */
	 case 'e': {
	    char *p;
	    if ( *(argv[1]+2) != '\0' )
	       p = argv[1]+2;
	    else {
	       argv++;
	       argc--;
	       p = argv[1];
	       if ( !p )
		  error("no file name given for redirection of &errout");
	       }
	    if ( *p == '-' ) { /* let - be stdout */
/*
 * The following code is operating-system dependent [@istart.02].  Redirect
 *  stderr to stdout.
 */

#if PORT
   /* may not be possible */
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA
               /*
                * The following code is for Lattice 4.0.  It was different
                *  for Lattice 3.10 and probably won't work for other
                *  C compilers.
                */
	       stderr->_file = 1;
	       stderr->_flag = stdout->_flag;
#endif					/* AMIGA */

#if ATARI_ST || MSDOS || OS2 || VMS
               dup2(fileno(stdout),fileno(stderr));
#endif					/* ATARI_ST || MSDOS || VMS */

#if HIGHC_386
	       /*
	        * Don't like doing this, but it seems to work.
	        */
	       setbuf(stdout,NULL);
	       setbuf(stderr,NULL);
	       stderr->_fd = stdout->_fd;		
#endif					/* HIGHC_386 */

#if MACINTOSH
#if LSC
   /* cannot do */
#endif					/* LSC */
#if MPW
               close(fileno(stderr));
               dup(fileno(stdout));
#endif					/* MPW */
#endif					/* MACINTOSH */

#if MVS || VM
               /* May not be possible. */
#endif					/* MVS || VM */

#if UNIX
               /*
                * This relies on the way UNIX assigns file numbers.
                */
               close(fileno(stderr));
               dup(fileno(stdout));
#endif					/* UNIX */

/*
 * End of operating-system specific code.
 */

	        }
	     else    /* redirecting to named file */
	        if (freopen(p, WriteText, stderr) == NULL)
	           syserr("Unable to redirect &errout\n");
	    break;
	    }
        }
	argc--;
	argv++;
      }

   /*
    * Read in the icode file argv[1] and initialize the Icon system.
    */
   icon_init(argv[1]);

   /*
    * skip the executable and the file.
    */
   myargv = argv + 2;
   myargc = argc - 2;

   /*
    * Set up a temporary stack and build the necessary list
    *  to call main.
    */
   sp = stack + Wsizeof(struct b_coexpr);

   PushNull;
   argp = (dptr)(sp - 1);
   for (i = 0; i < myargc; i++) {
      PushAVal(strlen(myargv[i]));
      PushVal(myargv[i]);
      }

   Ollist(myargc, argp);

   /*
    * Now that the list is computed, copy its descriptor off the
    *  stack (which is about to be destroyed), and make the call.
    *  WARNING - we wouldn't want a garbage collection to take place
    *  right here.  I don't think it can.
    */
 
   darg = *argp;
   argp = 0;
   retval = icon_run("main", 1, &darg);

}
#else					/* CallIn */
char x;
#endif					/* CallIn */
